Index: applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/msg/messages.properties
===================================================================
--- applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/msg/messages.properties	(revision 27146)
+++ applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/msg/messages.properties	(revision 27151)
@@ -277,2 +277,5 @@
 Windmill=Windmill
 SpireMinaret=Spire/Minaret
+
+NotDecimal=Not a valid decimal string
+TooBig=Maximum value exceeded
Index: applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/msg/messages_de.properties
===================================================================
--- applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/msg/messages_de.properties	(revision 27146)
+++ applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/msg/messages_de.properties	(revision 27151)
@@ -277,2 +277,5 @@
 Windmill=Windmill
 SpireMinaret=Spire/Minaret
+
+NotDecimal=Not a valid decimal string
+TooBig=Maximum value exceeded
Index: applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/msg/messages_en.properties
===================================================================
--- applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/msg/messages_en.properties	(revision 27146)
+++ applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/msg/messages_en.properties	(revision 27151)
@@ -277,2 +277,5 @@
 Windmill=Windmill
 SpireMinaret=Spire/Minaret
+
+NotDecimal=Not a valid decimal string
+TooBig=Maximum value exceeded
Index: applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/panels/PanelSectors.java
===================================================================
--- applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/panels/PanelSectors.java	(revision 27146)
+++ applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/panels/PanelSectors.java	(revision 27151)
@@ -183,9 +183,11 @@
 			case 10:
 			case 11:
-				dlg.mark.setLightAtt(col - 1, row, dlg.mark.validDecimal((String) value));
+				dlg.mark.setLightAtt(col - 1, row, value);
 				break;
 			case 6:
 				if ((Boolean) value == true) {
 					dlg.mark.setLightAtt(Att.LIT, row, Lit.DIR);
+					dlg.mark.setLightAtt(Att.BEG, row, "");
+					dlg.mark.setLightAtt(Att.END, row, "");
 				} else {
 					dlg.mark.setLightAtt(Att.LIT, row, Lit.UNKNOWN);
@@ -196,8 +198,7 @@
 			case 8:
 				if (dlg.mark.getLightAtt(Att.LIT, row) == Lit.DIR) {
-					dlg.mark.setLightAtt(Att.ORT, row, dlg.mark.validDecimal((String) value));
+					dlg.mark.setLightAtt(Att.ORT, row, value);
 				} else {
-					dlg.mark.setLightAtt(Att.LIT, row, Lit.UNKNOWN);
-					dlg.mark.setLightAtt(col - 1, row, dlg.mark.validDecimal((String) value));
+					dlg.mark.setLightAtt(col - 1, row, value);
 				}
 				break;
Index: applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/seamarks/SeaMark.java
===================================================================
--- applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/seamarks/SeaMark.java	(revision 27146)
+++ applications/editors/josm/plugins/smed/plugs/oseam/src/oseam/seamarks/SeaMark.java	(revision 27151)
@@ -9,4 +9,5 @@
 import org.openstreetmap.josm.command.ChangePropertyCommand;
 
+import oseam.Messages;
 import oseam.dialogs.OSeaMAction;
 
@@ -1091,6 +1092,6 @@
 	public String validDecimal(String str) {
 		str = str.trim().replace(',', '.');
-		if ((!str.isEmpty()) && (!str.matches("^[+-]??\\d+(\\.\\d+)??$"))) {
-			dlg.manager.showVisualMessage("Not a valid decimal string");
+		if (!(str.isEmpty()) && !(str.matches("^[+-]??\\d+(\\.\\d+)??$"))) {
+			dlg.manager.showVisualMessage(Messages.getString("NotDecimal"));
 			return "";
 		} else {
@@ -1100,8 +1101,8 @@
 	}
 
-	public String validDecimal(String str, int max) {
+	public String validDecimal(String str, float max) {
 		str = validDecimal(str);
-		if (!(str.isEmpty()) && (new Integer(str) > max)) {
-			dlg.manager.showVisualMessage("Maximum value exceeded");
+		if (!(str.isEmpty()) && (new Float(str) > max)) {
+			dlg.manager.showVisualMessage(Messages.getString("TooBig"));
 			return "";
 		} else {