Index: applications/editors/josm/plugins/undelete/build.xml
===================================================================
--- applications/editors/josm/plugins/undelete/build.xml	(revision 27355)
+++ applications/editors/josm/plugins/undelete/build.xml	(revision 27395)
@@ -32,5 +32,5 @@
     <property name="commit.message" value="adapt to core changes (backwards compatible)"/>
     <!-- enter the *lowest* JOSM version this plugin is currently compatible with -->
-    <property name="plugin.main.version" value="4602"/>
+    <property name="plugin.main.version" value="4734"/>
     <!--
       ************************************************
@@ -145,8 +145,8 @@
     </target>
     <!--
-    ************************** Publishing the plugin *********************************** 
-    -->
-    <!--
-        ** extracts the JOSM release for the JOSM version in ../core and saves it in the 
+    ************************** Publishing the plugin ***********************************
+    -->
+    <!--
+        ** extracts the JOSM release for the JOSM version in ../core and saves it in the
         ** property ${coreversion.info.entry.revision}
         **
@@ -194,15 +194,15 @@
     </target>
     <!--
-        ** commits the plugin.jar 
+        ** commits the plugin.jar
         -->
     <target name="commit-dist">
         <echo>
     ***** Properties of published ${plugin.jar} *****
-    Commit message    : '${commit.message}'                 
+    Commit message    : '${commit.message}'
     Plugin-Mainversion: ${plugin.main.version}
     JOSM build version: ${coreversion.info.entry.revision}
     Plugin-Version    : ${version.entry.commit.revision}
-    ***** / Properties of published ${plugin.jar} *****                 
-                        
+    ***** / Properties of published ${plugin.jar} *****
+
     Now commiting ${plugin.jar} ...
     </echo>
Index: applications/editors/josm/plugins/undelete/src/org/openstreetmap/josm/plugins/undelete/Undelete.java
===================================================================
--- applications/editors/josm/plugins/undelete/src/org/openstreetmap/josm/plugins/undelete/Undelete.java	(revision 27355)
+++ applications/editors/josm/plugins/undelete/src/org/openstreetmap/josm/plugins/undelete/Undelete.java	(revision 27395)
@@ -27,4 +27,5 @@
 import org.openstreetmap.josm.data.osm.Relation;
 import org.openstreetmap.josm.data.osm.RelationMember;
+import org.openstreetmap.josm.data.osm.RelationMemberData;
 import org.openstreetmap.josm.data.osm.SimplePrimitiveId;
 import org.openstreetmap.josm.data.osm.User;
@@ -70,5 +71,6 @@
       }
 
-      public void actionPerformed(ActionEvent e) {
+      @Override
+	public void actionPerformed(ActionEvent e) {
         JCheckBox layer = new JCheckBox(tr("Separate Layer"));
         layer.setToolTipText(tr("Select if the data should be added into a new layer"));
@@ -120,5 +122,5 @@
         Main.pref.put("undelete.osmid", Long.toString(tfId.getOsmId()));
         List<Long> ids=new ArrayList<Long>();
-        ids.add((long)tfId.getOsmId());
+        ids.add(tfId.getOsmId());
         undelete(layer.isSelected(), cbType.getType(), ids, 0);
       }
@@ -149,5 +151,6 @@
 
         Runnable r = new Runnable() {
-            public void run() {
+            @Override
+			public void run() {
               List<Node> nodes=new ArrayList<Node>();
               for (long id: ids)
@@ -225,11 +228,11 @@
 
                       List<RelationMember> members = new ArrayList<RelationMember>(hRel.getNumMembers());
-                      for (org.openstreetmap.josm.data.osm.history.RelationMember m : hRel.getMembers()) {
-                        OsmPrimitive p = datas.getPrimitiveById(m.getPrimitiveId(), m.getPrimitiveType());
+                      for (RelationMemberData m : hRel.getMembers()) {
+                        OsmPrimitive p = datas.getPrimitiveById(m.getMemberId(), m.getMemberType());
                         if (p == null) {
-                            switch (m.getPrimitiveType()) {
-                            case NODE: p = new Node(m.getPrimitiveId()); break;
-                            case WAY: p = new Way(m.getPrimitiveId()); break;
-                            case RELATION: p = new Relation(m.getPrimitiveId()); break;
+                            switch (m.getMemberType()) {
+                            case NODE: p = new Node(m.getMemberId()); break;
+                            case WAY: p = new Way(m.getMemberId()); break;
+                            case RELATION: p = new Relation(m.getMemberId()); break;
                             }
                             datas.addPrimitive(p);